﻿-------------------------------------------------------------------------------
--         Расширенная работа с выделением файлов. © SimSU
-------------------------------------------------------------------------------
Macro {
area="Shell"; key="Divide"; description="Пометка одинаковых файлов на обоих панелях. © SimSU";
condition = function() return APanel.FilePanel and PPanel.Visible and PPanel.FilePanel end;
action = function()
  local AFiles={}
  for i=1,panel.GetPanelInfo(nil,1).ItemsNumber do
    AFiles[i]=panel.GetPanelItem(nil,1,i).FileName
  end
  AFiles=table.concat(AFiles,"\n")
  local PFiles={} for i=1,panel.GetPanelInfo(nil,0).ItemsNumber do
    PFiles[i]=panel.GetPanelItem(nil,0,i).FileName
  end
  PFiles=table.concat(PFiles,"\n")
  Panel.Select(0,0) Panel.Select(0,1,2,PFiles)
  Panel.Select(1,0) Panel.Select(1,1,2,AFiles)
end;
}

Macro {
area="Shell"; key="CtrlShiftM"; description="Пометка файлов имена которых находятся в буфере обмена. © SimSU";
condition = function() return APanel.FilePanel end;
action = function()
  -- panel.select(0,1,2,clip(0)) -- FAR не проверяет пути если они есть.
  -- Делаем работу за FAR.
  local FileList=mf.clip(0)
  FileList=FileList:gsub("[%,%;\r\"]","\n"):upper().."\n"
  local PanelPath=APanel.Path:upper()
  for FullFileName in FileList:gmatch("[^\n]+") do
    local FilePath=mf.fsplit(FullFileName,0x1+0x2)
    local FileName=mf.fsplit(FullFileName,0x4+0x8)
    if FilePath=="" or FilePath==PanelPath then
      Panel.Select(0,1,2,FileName)
    end
  end
end;
}

Macro {
area="Shell"; key="CtrlShiftR"; description="Снятие пометки файлов имена которых находятся в буфере обмена. © SimSU";
condition = function() return APanel.FilePanel end;
action = function()
  -- panel.select(0,0,2,clip(0)) -- FAR не проверяет пути если они есть.
  -- Делаем работу за FAR.
  local FileList=mf.clip(0)
  FileList=FileList:gsub("[%,%;\r\"]","\n"):upper().."\n"
  local PanelPath=APanel.Path:upper()
  for FullFileName in FileList:gmatch("[^\n]+") do
    local FilePath=mf.fsplit(FullFileName,0x1+0x2)
    local FileName=mf.fsplit(FullFileName,0x4+0x8)
    if FilePath=="" or FilePath==PanelPath then
      Panel.Select(0,0,2,FileName)
    end
  end
end;
}

Macro {
area="Shell"; key="AltHome"; flags="Selection"; description="Переход на первый выделенный файл. © SimSU";
action = function()
  Panel.SetPosIdx(0,1,1)
end;
}

Macro {
area="Shell"; key="AltUp"; flags="Selection"; description="Переход на предыдущий выделенный файл. © SimSU";
action = function()
  if Panel.SetPosIdx(0,0,1)==1 then
    --Panel.SetPosIdx(0,APanel.SelCount,1)
    mf.beep(0x30)
  else
    Panel.SetPosIdx(0,Panel.SetPosIdx(0,0,1)-1,1)
  end
end;
}

Macro {
area="Shell"; key="AltDown"; flags="Selection"; description="Переход на следующий выделенный файл. © SimSU";
action = function()
  if Panel.SetPosIdx(0,0,1)==APanel.SelCount then
    --Panel.SetPosIdx(0,1,1)
    mf.beep(0x30)
  else
    Panel.SetPosIdx(0,Panel.SetPosIdx(0,0,1)+1,1)
  end
end;
}

Macro {
area="Shell"; key="AltEnd"; flags="Selection"; description="Переход на последний выделенный файл. © SimSU";
action = function()
  Panel.SetPosIdx(0,APanel.SelCount,1)
end;
}

Macro {
area="Shell"; key="CtrlShiftE"; description="Копирование имён помеченных файлов в редактор. © SimSU";
action = function()
  local Files={}
  for i=1, panel.GetPanelInfo(nil,1).SelectedItemsNumber do
    Files[i]=panel.GetSelectedPanelItem(nil,1,i).FileName
  end
  Files=table.concat(Files,"\r\n")
  Keys("ShiftF4 CtrlY Enter")
  if Area.Dialog and Dlg.Id == "AFDAD388-494C-41E8-BAC6-BBE9115E1CC0"then Keys("Tab Enter") end
  if Area.Editor then print(Files) end

end;
}

Macro {
area="Shell"; key="Alt/"; description="Работа с пометкой файлов. © SimSU";
action = function()
  local RorE= win.GetEnv("farlang")=="Russian"
  local item=Menu.Show(RorE
    and "&E Имена в редактор\n\1 Буфер обмена\n&C Копировать\n&M Пометить\n&R Снять пометку\n\1 Панели\n&S Синхронизировать\n&A +Имена\n&T +Расширения\n&B -Имена\n&U -Расширения\n&+ Выделить\n&- Снять выделение\n\1 Передвижение\n&F Первый\n&P Предыдущий\n&N Следующий\n&L Последний"
    or  "&E Name to editor\n\1 Clipboard\n&C Copy\n&M Mark\n&R Remove mark\n\1 Panels\n&S Synchronize\n&A +Names\n&T +Expansions\n&B -Names\n&U -Expansions\n&+ Add mark\n&- Remove mark\n\1 Movement\n&F First\n&P Previous\n&N Next\n&L Last",
  RorE and "Работа с пометкой © SimSU" or "Work with mark © SimSU",0x8)
  if     item== 1 then eval("Shell/CtrlShiftE",2)
  elseif item== 3 then Keys("CtrlShiftIns")
  elseif item== 4 then eval("Shell/CtrlShiftM",2) --Panel.Select(0,1,2,mf.clip(0))
  elseif item== 5 then eval("Shell/CtrlShiftR",2) --Panel.Select(0,0,2,mf.clip(0))
  elseif item== 7 then eval("Shell/Divide",2)
  elseif item== 8 then Keys("AltAdd")
  elseif item== 9 then Keys("CtrlAdd")
  elseif item==10 then Keys("AltSubtract")
  elseif item==11 then Keys("CtrlSubtract")
  elseif item==12 then Keys("Add")
  elseif item==13 then Keys("Subtract")
  elseif item==15 then Panel.SetPosIdx(0,1,1) -- eval("Shell/AltHome",2)
  elseif item==16 then eval("Shell/AltUp",2)
  elseif item==17 then eval("Shell/AltDown",2)
  elseif item==18 then Panel.SetPosIdx(0,APanel.SelCount,1) -- eval("Shell/AltEnd",2)
  end
end;
}
