local MultiViewGUID = "DFF5557F-65A3-4B79-A474-93264E0382BF";

local function MultiView()
	local KeysArray = {
		AltDown       = "a",   -- Volume down
		AltEnd        = "7",   -- Go to End
		AltHome       = "6",   -- Go to Start
		AltLeft       = "4",   -- Step Back
		AltRight      = "2",   -- Step Forward
		AltUp         = "q",   -- Volume Up
		CtrlAltLeft   = "5",   -- Jump Forward
		CtrlAltRight  = "3",   -- Jump Back
		CtrlJ         = "j",   -- Jump to ...
		CtrlR         = "r",   -- Restart
		CtrlSpace     = "9",   -- Stop
		Multiply      = "1",   -- Toggle fit window
		Space         = "8"    -- Play/Pause
	};
	local key = KeysArray[mf.akey(2)];

	Plugin.Menu(MultiViewGUID);
	if Area.Current == "Menu" and Menu.Id == MultiViewGUID then
		if Object.CheckHotkey(key) ~= 0 then
			Keys(key);
		else
			Keys("Esc")
		end
	end
end

Macro {
	area="Viewer";
	key="AltDown AltEnd AltHome AltLeft AltRight AltUp CtrlAltLeft CtrlAltRight CtrlJ CtrlR CtrlSpace Multiply Space";
	flags="DisableOutput";
	condition = function()
		return Plugin.Exist(MultiViewGUID)
	end;
	action=MultiView;
}
